


<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html id="htmlId">
<head>
  <title>Coverage Report :: AbstractJpaRepository</title>
  <style type="text/css">
    @import "../../.css/coverage.css";
  </style>
</head>

<body>
<div class="header"></div>

<div class="content">
<div class="breadCrumbs">
    [ <a href="../../index.html">all classes</a> ]
    [ <a href="../index.html">com.dema.timeregistration.repository.jpa</a> ]
</div>

<h1>Coverage Summary for Class: AbstractJpaRepository (com.dema.timeregistration.repository.jpa)</h1>

<table class="coverageStats">
<tr>
  <th class="name">Class</th>
<th class="coverageStat 
">
  Class, %
</th>
<th class="coverageStat 
">
  Method, %
</th>
<th class="coverageStat 
">
  Line, %
</th>
</tr>
<tr>
  <td class="name">AbstractJpaRepository</td>
<td class="coverageStat">
  <span class="percent">
    100%
  </span>
  <span class="absValue">
    (1/ 1)
  </span>
</td>
<td class="coverageStat">
  <span class="percent">
    83.3%
  </span>
  <span class="absValue">
    (5/ 6)
  </span>
</td>
<td class="coverageStat">
  <span class="percent">
    91.7%
  </span>
  <span class="absValue">
    (22/ 24)
  </span>
</td>
</tr>

</table>

<br/>
<br/>


<div class="sourceCode"><i>1</i>&nbsp;package com.dema.timeregistration.repository.jpa;
<i>2</i>&nbsp;
<i>3</i>&nbsp;import com.dema.timeregistration.entity.EntityWithId;
<i>4</i>&nbsp;import com.dema.timeregistration.repository.CrudRepository;
<i>5</i>&nbsp;
<i>6</i>&nbsp;import javax.persistence.EntityManager;
<i>7</i>&nbsp;import javax.persistence.TypedQuery;
<i>8</i>&nbsp;import javax.persistence.criteria.CriteriaBuilder;
<i>9</i>&nbsp;import javax.persistence.criteria.CriteriaQuery;
<i>10</i>&nbsp;import javax.persistence.criteria.ParameterExpression;
<i>11</i>&nbsp;import javax.persistence.criteria.Root;
<i>12</i>&nbsp;import java.util.Optional;
<i>13</i>&nbsp;
<i>14</i>&nbsp;/**
<i>15</i>&nbsp; * Extend this class to create a Jpa based repository with basic CRUD functionality.
<i>16</i>&nbsp; *
<i>17</i>&nbsp; * @param &lt;TEntity&gt; The entity type that the repository will provide access to
<i>18</i>&nbsp; */
<i>19</i>&nbsp;public abstract class AbstractJpaRepository&lt;TEntity extends EntityWithId&gt; implements CrudRepository&lt;TEntity&gt; {
<i>20</i>&nbsp;    protected final EntityManager entityManager;
<i>21</i>&nbsp;
<i>22</i>&nbsp;    /**
<i>23</i>&nbsp;     * We can&#39;t obtain a reference to the Class type
<i>24</i>&nbsp;     */
<i>25</i>&nbsp;    private final Class&lt;TEntity&gt; type;
<i>26</i>&nbsp;
<b class="fc"><i>27</i>&nbsp;    public AbstractJpaRepository(EntityManager entityManager, Class&lt;TEntity&gt; type) {</b>
<b class="fc"><i>28</i>&nbsp;        this.entityManager = entityManager;</b>
<b class="fc"><i>29</i>&nbsp;        this.type = type;</b>
<b class="fc"><i>30</i>&nbsp;    }</b>
<i>31</i>&nbsp;
<i>32</i>&nbsp;
<i>33</i>&nbsp;    @Override
<i>34</i>&nbsp;    public void save(TEntity entity) {
<b class="fc"><i>35</i>&nbsp;        withinTransaction(() -&gt; {</b>
<b class="fc"><i>36</i>&nbsp;            if (entity.getId() == 0) {</b>
<i>37</i>&nbsp;                // If an entity has Id 0, we assume that it has never been persisted
<b class="fc"><i>38</i>&nbsp;                entityManager.persist(entity);</b>
<i>39</i>&nbsp;            } else {
<b class="fc"><i>40</i>&nbsp;                entityManager.merge(entity);</b>
<i>41</i>&nbsp;            }
<b class="fc"><i>42</i>&nbsp;        });</b>
<b class="fc"><i>43</i>&nbsp;    }</b>
<i>44</i>&nbsp;
<i>45</i>&nbsp;    public Optional&lt;TEntity&gt; findById(int id) {
<b class="fc"><i>46</i>&nbsp;        CriteriaBuilder cb = entityManager.getCriteriaBuilder();</b>
<b class="fc"><i>47</i>&nbsp;        CriteriaQuery&lt;TEntity&gt; cq = cb.createQuery(type);</b>
<i>48</i>&nbsp;
<b class="fc"><i>49</i>&nbsp;        Root&lt;TEntity&gt; e = cq.from(type);</b>
<b class="fc"><i>50</i>&nbsp;        ParameterExpression&lt;Integer&gt; p = cb.parameter(Integer.class);</b>
<b class="fc"><i>51</i>&nbsp;        cq.select(e).where(cb.equal(e.get(&quot;id&quot;), p));</b>
<i>52</i>&nbsp;
<b class="fc"><i>53</i>&nbsp;        TypedQuery&lt;TEntity&gt; query = entityManager.createQuery(cq);</b>
<b class="fc"><i>54</i>&nbsp;        query.setParameter(p, id);</b>
<i>55</i>&nbsp;
<b class="fc"><i>56</i>&nbsp;        return query.getResultStream().findFirst();</b>
<i>57</i>&nbsp;    }
<i>58</i>&nbsp;
<i>59</i>&nbsp;    @Override
<i>60</i>&nbsp;    public void delete(TEntity entity) {
<b class="nc"><i>61</i>&nbsp;        entityManager.remove(entity);</b>
<b class="nc"><i>62</i>&nbsp;    }</b>
<i>63</i>&nbsp;
<i>64</i>&nbsp;    protected void withinTransaction(Runnable f) {
<b class="fc"><i>65</i>&nbsp;        entityManager.getTransaction().begin();</b>
<b class="fc"><i>66</i>&nbsp;        f.run();</b>
<b class="fc"><i>67</i>&nbsp;        entityManager.getTransaction().commit();</b>
<b class="fc"><i>68</i>&nbsp;    }</b>
<i>69</i>&nbsp;}
</div>
</div>

<div class="footer">
    
    <div style="float:right;">generated on 2019-05-13 13:51</div>
</div>
</body>
</html>
